/*->c.deb */


#include "StdAfx.h"



#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>
#include <stdarg.h>


#include "os.h"

#include "etc.h"

#include "deb.h"

#define VSNPRINTF(a,b,c,d,e) ((((e)=_vsnprintf((a),(b),(c),(d)))<0)?((a)[(b)-1]=0,(e)):(e))
#define VSNWPRINTF(a,b,c,d,e) ((((e)=_vsnwprintf((a),(b),(c),(d)))<0)?((a)[(b)-1]=0,(e)):(e))
#define VSNTPRINTF(a,b,c,d,e) ((((e)=_vsntprintf((a),(b),(c),(d)))<0)?((a)[(b)-1]=0,(e)):(e))

#define NITEM(a) (sizeof((a))/sizeof((*a)))


static FILE * dbfp;



static HANDLE consoleh=NULL;


void xcprintf(char * format, ...)
{
 va_list   args;
 char      v[512];
 DWORD     numw;
// CONSOLE_SCREEN_BUFFER_INFO ConsoleScreenBufferInfo;


 if(consoleh==NULL)
 {
  FreeConsole();
  AllocConsole(); 

  consoleh=GetStdHandle(STD_OUTPUT_HANDLE);

//  GetConsoleScreenBufferInfo(consoleh,&ConsoleScreenBufferInfo);
  
//  ConsoleScreenBufferInfo.dwSize.Y=256;

//  SetConsoleScreenBufferSize(consoleh,ConsoleScreenBufferInfo.dwSize);
 }


 va_start(args, format);
 numw=VSNPRINTF(v,(sizeof(v)-2)/sizeof(TCHAR),format,args,numw);
 strcat(v,"\r\n");
 WriteConsole(consoleh,v,strlen(v),&numw,NULL);

 va_end(args);
}


// OutputDebugString(string); 




void xcprintfw(wchar_t * format, ...)
{
 va_list   args;
 wchar_t   v[512];
 DWORD     numw;



 if(consoleh==NULL)
 {
  FreeConsole();
  AllocConsole(); 
  consoleh=GetStdHandle(STD_OUTPUT_HANDLE);
 }


 va_start(args, format);
 numw=VSNWPRINTF(v,NITEM(v)-2,format,args,numw);
 wcscat(v,L"\r\n");
 WriteConsoleW(consoleh,v,wcslen(v),&numw,NULL);

 va_end(args);
}





void xdprintf(int line,char * format, ...)
{
 va_list   args;
 char      v[512];
 HDC       hdc;
 HFONT     font;
 int       len;
// HWND      hwnd;

 va_start(args, format);
 VSNPRINTF(v,sizeof(v)/sizeof(TCHAR),format,args,len);

// hwnd=GetDesktopWindow();
// GetClientRect(hwnd,&rect);
 
 hdc=GetDC(NULL);

 font=(HFONT)GetStockObject(SYSTEM_FONT);
 SelectObject(hdc,(void*)font);
 SetTextColor(hdc,RGB(0,0,0));
 SetBkColor(hdc,RGB(255,255,255));
 TextOut(hdc,0,0+line*10,v,strlen(v));

 ReleaseDC(NULL,hdc);

 va_end(args);
}






char * dbpath="C:\\Program Files\\Microsoft Visual Studio\\MyProjects\\CrossStar\\xx.c";


void lprintf(char * format, ...)
{
 va_list   args;
 char      v[512];
// char      string[512];
// char    * p;
 FILE    * fp;
 int       len;

 va_start(args, format);
 VSNPRINTF(v,sizeof(v)/sizeof(TCHAR),format,args,len);

// sprintf(string,"%s$Log",wimpt_programname());
// if((p=getenv(string))!=NULL)
 {
//  strcpy(string,p);
  fp=fopen(dbpath,"ab+");
  if(fp)
  {
   fprintf(fp,"%s\n",v);
   fclose(fp);
  }
 }

 va_end(args);
}





void lerror(char * v,os_error * err)
{
 FILE * fp;
// char   string[256];
// char * p;

 if(err)
 {
   fp=fopen(dbpath,"ab+");
   if(fp)
   {
    fprintf(fp,"%s (%s)\n",v,err->errmess);
    fclose(fp);
   }
 }
}


int  debugactive(void)
{
#ifdef _DEBUG
 return(1);
#else
 return(0);
#endif
}


int  debugactive2(void)
{
#ifdef _DEBUG
 return(1);
#else
 return(0);
#endif
}