// Version 1.05 19/05/2004
//

int SRWE_window, SRWE_active, SRWE_view;
string SRWE_findstring;
string SRWE_replacestring;
string SRWE_stylename;
string SRWE_findstylename;
string SRWE_replacestylename;
int SRWE_bold = 0;
int SRWE_italic = 0;
int SRWE_underline = 0;
int SRWE_reverse = 0;
int SRWE_case = 0;
int SRWE_word = 0;
int SRWE_all = 0;
int SRWE_start = 0;
int SRWE_wild = 0;
int SRWE_b1, SRWE_b2,SRWE_b3, SRWE_b4, SRWE_more;
int SRWE_style_handle;
int SRWE_findstyle = 0;
int SRWE_replacestyle = 0;
int SRWE_removestyle;
int SRWE_frmenu;

void SRWE_replacefinished(int handle)
{
  if (SRWE_active != 0)
    {
    if(handle==1) setcarettobm(SRWE_b1);
    else          setcarettobm(SRWE_b3);

    bmdelete(SRWE_b1);
    bmdelete(SRWE_b2);
    bmdelete(SRWE_b3);
    bmdelete(SRWE_b4);
    SRWE_active=0;

    close_window(SRWE_window);
    delete_window(SRWE_window);
    }
}

void replace_word(void)
{
  int st = 0 ;
  string replaceSt = "" ;
  int do_copy = 0 ;

  SRWE_replacestring = readicon (SRWE_window, 7);

  if (SRWE_wild != 0)
    {
    int ch = sins (SRWE_replacestring, "\\", 0) ;
    string copySt = "" ;

    while (ch != -1)
      {
      replaceSt += mids (SRWE_replacestring, st, ch - st) ;
      switch (schar (SRWE_replacestring, ch + 1))
        {
        case '&':
          if (copySt == "")
            {
            setbmtocaret (SRWE_b4) ;
            while (bmcmp (SRWE_b4, SRWE_b2) < 0)
              {
              copySt += chars (bmchar (SRWE_b4)) ;
              bmmove (SRWE_b4, 1, 0) ;
              }
            }
          replaceSt += copySt ;
          break ;
        case 'n': replaceSt += "{NewPara}" ; break ;
        case 'g': replaceSt += "{PageNumber}" ; break ;
        case 'c': replaceSt += "{ChapterNumber}" ; break ;
        case 'h': replaceSt += "{ActiveDate}" ; break ;
        case '|': replaceSt += "{NewLine}" ; break ;
        case 't': replaceSt += "{Tabchar}" ; break ;
        case 'f': replaceSt += "{NewFrame}" ; break ;
        case '\\': replaceSt += "\\" ; break ;
        default: replaceSt += mids (SRWE_replacestring, ch, 2) ; break ;
        }
      st = ch + 2 ;
      ch = sins (SRWE_replacestring, "\\", st) ;
      }
    }
  else
    replaceSt += mids (SRWE_replacestring, st, slen (SRWE_replacestring) - st) ;

  type ("{'DELETE}") ;
  if (SRWE_findstyle != 0) remstyle(SRWE_removestyle);
  if (SRWE_replacestyle != 0) addstyle(SRWE_replacestyle);
  if (SRWE_bold == 1) seteffect(BOLD);
  if (SRWE_italic == 1) seteffect(ITALIC);
  if (SRWE_underline == 1) seteffect(UNDERLINE);
  if (SRWE_reverse == 1) seteffect(REVERSE);
  type (replaceSt);
}

int check_style(string& style_findname)
{
  int style_handle = 0;
  int style_match = 0;
  string style_actualname;

  while (getcurrentstyle(style_handle, style_actualname, 1))
    {
    if (style_findname==style_actualname)
      {
      style_match = 1;

      // we've found it, don't waste time looking for more
      break ;
      }
    style_handle++;
    }
  return ((style_match == 1) ? style_handle : -1);
}

void SRWE_findmatch(void)
{
  SRWE_findstring = readicon(SRWE_window, 6);

  setactive (viewhandle (SRWE_view)) ;
  setfocus (viewhandle (SRWE_view)) ;

  SRWE_removestyle = -1;
  SRWE_more = 0;
  while ((SRWE_removestyle == -1) && (SRWE_more == 0))
    {
    SRWE_more = bmsearch(SRWE_b1, SRWE_b2, SRWE_findstring,
                         SRWE_wild | SRWE_word | SRWE_case);
    if (SRWE_more != 0 && SRWE_all != 0)
      {
      SRWE_more = bmnextstory (SRWE_b1) ;
      setcarettobm(SRWE_b1);
      setbmtocaret(SRWE_b2);
      }
    else if (SRWE_more==0)
      {
      setcarettobm(SRWE_b1);
      setzonetobm(SRWE_b2);
      if (SRWE_findstyle!=0)
        {
        SRWE_removestyle = check_style(SRWE_findstylename);
        } else  SRWE_removestyle=0;
      setbmtobm (SRWE_b1, SRWE_b2) ;
      }
    if (SRWE_more != 0)
      SRWE_replacefinished(0);
    }
}

void SRWE_replacestart(void)
{
  SRWE_replacestring = readicon(SRWE_window, 7);
  SRWE_findstring = readicon(SRWE_window, 6);

  if (SRWE_findstring != "")
    {
    if (SRWE_all != 0)
      {
      bmstartscan() ;
      bmnextstory (SRWE_b1) ;
      }

    if (SRWE_start != 0)
      {
      type ("{'C_Home}") ;
      setbmtocaret(SRWE_b1);
      bmmove(SRWE_b1, 0, 1);
      }

    set_icon_state(SRWE_window, 3, 1<<22, 0);
    set_icon_state(SRWE_window, 4, 1<<22, 0);
    set_icon_state(SRWE_window, 5, 1<<22, 0);
    set_icon_state(SRWE_window, 1, 1<<22, 1<<22);
    SRWE_findmatch();
    }
  else
    {
    insert_caret (SRWE_window, 6) ;
    bbc_vdu(7);
    }
}

void SRWE_replaceall(void)
{
  replace_word();
  SRWE_findmatch();
  while(SRWE_more == 0)
    {
    replace_word();
    SRWE_findmatch();
    }
  SRWE_replacefinished(0);
}

void SRWE_replaceone(void)
{
  replace_word();
  SRWE_findmatch();
}

int menu_select(int menu_item, int subcode)
{
  SRWE_stylename = ((menu_item!=0) ? string_menu(SRWE_style_handle, menu_item) : " no style");
  if (SRWE_frmenu == 23)
    {
    SRWE_findstyle =menu_item;
    SRWE_findstylename = SRWE_stylename;
    }
  if (SRWE_frmenu == 24)
    {
    SRWE_replacestyle = menu_item;
    SRWE_replacestylename = SRWE_stylename;
    }
  writeicon(SRWE_window, SRWE_frmenu, SRWE_stylename);
  return(subcode);
}

void SRWE_activeview(int user, int view, int gain)
{
  if (!gain && SRWE_active && view && view == SRWE_view)
    {
    int view ;

    view=currentview();
    setcurrentview(SRWE_view);
    SRWE_replacefinished (0) ;
    setcurrentview(view);
    }
}

int replace_entry(int entry, int subcode)
{
  int style_handle;
  string str ;
  string str2 ;
  int bm ;
  int i ;

  if (SRWE_active == 0)
    {
    SRWE_view = activeview () ;
    SRWE_window = create_windowparent("SRWEffect", viewhandle (SRWE_view));
    addwindowhandler(0, SRWE_window, "SRWE_mouseclick");
    addwindowhandler(2, SRWE_window, "SRWE_replacefinished");
    addwindowhandler(3, SRWE_window, "SRWE_openWindow") ;

    SRWE_active = 1;
    SRWE_b1 = bmcreate("replace_SRWE_b1");
    SRWE_b2 = bmcreate("replace_SRWE_b2");
    SRWE_b3 = bmcreate("origin_SRWE_b3");
    SRWE_b4 = bmcreate("replace_SRWE_b4");

    setbmtocaret(SRWE_b3);
    setbmtocaret(SRWE_b1);
    bmmove(SRWE_b1, 0, 1);

    SRWE_style_handle = create_menu("Styles");
    SRWE_more = getuserstyle(style_handle, SRWE_stylename, 1);
    while(SRWE_more != 0)
      {
      addentry_menu(SRWE_style_handle, "menu_select", "", "", "", SRWE_stylename);
      style_handle += 1;
      SRWE_more = getuserstyle(style_handle, SRWE_stylename, 0);
      }

    display_window(SRWE_window, 0, 3);
    set_icon_state(SRWE_window, 3, 1<<22, 1<<22);
    set_icon_state(SRWE_window, 4, 1<<22, 1<<22);
    set_icon_state(SRWE_window, 5, 1<<22, 1<<22);
    writeicon (SRWE_window, 6, SRWE_findstring);
    writeicon (SRWE_window, 7, SRWE_replacestring);
    if (SRWE_findstyle) writeicon(SRWE_window, 23, SRWE_findstylename);
    if (SRWE_replacestyle) writeicon(SRWE_window, 24, SRWE_replacestylename);

    if (SRWE_bold)      set_icon_state(SRWE_window, 8,  1<<21, 0);
    if (SRWE_italic)    set_icon_state(SRWE_window, 9,  1<<21, 0);
    if (SRWE_underline) set_icon_state(SRWE_window, 10, 1<<21, 0);
    if (SRWE_reverse)   set_icon_state(SRWE_window, 11, 1<<21, 0);
    if (SRWE_case)      set_icon_state(SRWE_window, 12, 1<<21, 0);
    if (SRWE_word)      set_icon_state(SRWE_window, 13, 1<<21, 0);
    if (SRWE_wild)      set_icon_state(SRWE_window, 14, 1<<21, 0);
    if (SRWE_all)       set_icon_state(SRWE_window, 15, 1<<21, 0);
    if (SRWE_start)     set_icon_state(SRWE_window, 16, 1<<21, 0);
    }
  else bbc_vdu(7);
  return(subcode);
}

void SRWE_togglebold(int icon)
{
  SRWE_bold = (SRWE_bold ^ 1);
  set_icon_state(SRWE_window, icon, 1<<21, 0);
}

void SRWE_toggleitalic(int icon)
{
  SRWE_italic = (SRWE_italic ^ 1);
  set_icon_state(SRWE_window, icon, 1<<21, 0);
}

void SRWE_toggleunderline(int icon)
{
  SRWE_underline = (SRWE_underline ^ 1);
  set_icon_state(SRWE_window, icon, 1<<21, 0);
}

void SRWE_togglereverse(int icon)
{
  SRWE_reverse = (SRWE_reverse ^ 1);
  set_icon_state(SRWE_window, icon, 1<<21, 0);
}

void SRWE_togglecase(int icon)
{
  SRWE_case = (SRWE_case ^ 1);
  set_icon_state(SRWE_window, icon, 1<<21, 0);
}

void SRWE_toggleWholeWord(int icon)
{
  SRWE_word = (SRWE_word ^ 2);
  set_icon_state(SRWE_window, icon, 1<<21, 0);
}

void SRWE_toggleAllStories(int icon)
{
  SRWE_all = (SRWE_all ^ 4);
  set_icon_state(SRWE_window, icon, 1<<21, 0);
}

void SRWE_toggleFindStart(int icon)
{
  SRWE_start = (SRWE_start ^ 8);
  set_icon_state(SRWE_window, icon, 1<<21, 0);
}

void SRWE_toggleWildcards(int icon)
{
  SRWE_wild = (SRWE_wild ^ 16);
  set_icon_state(SRWE_window, icon, 1<<21, 0);
  if (SRWE_wild == 0)
    extent_window (SRWE_window, 0, geticon (SRWE_window, 0, 1),
                   geticon (SRWE_window, 0, 2), 0) ;
  else
    extent_window (SRWE_window, 0, geticon (SRWE_window, 17, 1),
                   geticon (SRWE_window, 17, 2), 0) ;
  refresh_icon (0, SRWE_window, -1) ;
  display_window (SRWE_window, 0, 2) ;
}

void SRWE_mouseclick(int handle, int icon, int bbits, int mx, int my)
{
  switch (icon)
    {
    case 1:SRWE_replacestart(); break;
    case 2:SRWE_replacefinished(1); break;
    case 3:SRWE_replaceone(); break;
    case 4:SRWE_findmatch(); break;
    case 5:SRWE_replaceall(); break;

    case 8:SRWE_togglebold(icon); break;
    case 9:SRWE_toggleitalic(icon); break;
    case 10:SRWE_toggleunderline(icon); break;
    case 11:SRWE_togglereverse(icon); break;
    case 12:SRWE_togglecase(icon); break;
    case 13:SRWE_toggleWholeWord(icon); break;
    case 14:SRWE_toggleWildcards(icon) ; break ;
    case 15:SRWE_toggleAllStories(icon) ; break ;
    case 16:SRWE_toggleFindStart(icon) ; break ;

    case 25:SRWE_frmenu = 23; open_menu(SRWE_style_handle); break;
    case 26:SRWE_frmenu = 24; open_menu(SRWE_style_handle); break;

    case 27: fx (138, 0, '\\') ; fx (138, 0, '.') ; break ;
    case 28: fx (138, 0, '\\') ; fx (138, 0, 'd') ; break ;
    case 29: fx (138, 0, '\\') ; fx (138, 0, 'a') ; break ;
    case 30: fx (138, 0, '\\') ; fx (138, 0, '*') ; break ;
    case 31: fx (138, 0, '\\') ; fx (138, 0, '&') ; break ;
    case 32: fx (138, 0, '\\') ; fx (138, 0, '\\') ; break ;
    case 33: fx (138, 0, '\\') ; fx (138, 0, '|') ; break ;
    case 34: fx (138, 0, '\\') ; fx (138, 0, 'n') ; break ;
    case 35: fx (138, 0, '\\') ; fx (138, 0, 't') ; break ;
    case 36: fx (138, 0, '\\') ; fx (138, 0, 'g') ; break ;
    case 37: fx (138, 0, '\\') ; fx (138, 0, 'c') ; break ;
    case 38: fx (138, 0, '\\') ; fx (138, 0, 'h') ; break ;
    case 39: fx (138, 0, '\\') ; fx (138, 0, 'w') ; break ;
    case 40: fx (138, 0, '\\') ; fx (138, 0, 'e') ; break ;
    case 41: fx (138, 0, '\\') ; fx (138, 0, 'f') ; break ;
    case 42: fx (138, 0, '\\') ; fx (138, 0, 'm') ; break ;
    }
}

// shade or un-shade 'Replace' menu entry

int replace_flags(int entry, string &text)
{
  return((activetype(TEXTFRAME) <= 1) ? SHADED : 0);
}

void SRWE_openWindow(int h, int x0, int y0, int x1, int y1, int scx, int scy, int bh)
{
  if (SRWE_wild == 0)
    y0 = y1 + geticon (h, 0, 1) ;
  else
    y0 = y1 + geticon (h, 17, 1) ;

  open_window(h, x0, y0, x1, y1, scx, scy, bh);

  insert_caret (h, 6) ;
}
// add 'Replace' option to Applet menu

void main(void)
{
  string s = "{REPLACE_01}";

  script_menu_initialise();
  script_menu_insert("replace_entry","replace_flags","","","{REPLACE_00}");
  addeventhandler(0x215, 0, "SRWE_activeview");

  if (isdefmacro("srwe") == -1)
    {
    translate(s);
    defmacro3(0, "srwe",
              "{if (activetype(TEXTFRAME) > 0) replace_entry(0, 0);else beep(0,0,0)}",
              "srwe", s, "SRWE");
    }

  if (isdefmacro("CS_F4")==-1) defmacro3(1, "CS_F4", "{srwe}", "", "", "srwe") ;
}
