/*->c.csnaive */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "transform.h"
#include "xprocess.h"

#include "wos.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "colour.h"
#include "xmath.h"
#include "drag.h"
#include "conf.h"
#include "redraw.h"
#include "etc.h"
#include "bits.h"
#include "wimptext.h"
#include "fsx.h"
#include "bf.h"
#include "flex.h"
#include "scanplus.h"




#include "dbhi.h"
#include "mhi.h"


#include "str.h"
#include "constants.h"

#include "units.h"




#include "xcolour.h"
#include "xxcolour.h"
#include "cconv.h"


#include "colsep.h"
#include "colseplink.h"


#include "csview.h"

#include "cssp.h"

#include "csnaive.h"






os_error * csrgb2cmyk3232(int * s,int * d,int size)
{
 int word;
 int c;
 int m;
 int y;
 int k;

 while(size--)
 {
  word=*s++;
  c=0xFF-(word & 0xFF);
  m=0xFF-((word & 0xFF00)>>8);
  y=0xFF-((word & 0xFF0000)>>16);

  k=MIN(c,m);
  k=MIN(k,y);

  c-=k;
  m-=k;
  y-=k;

  *d++=(k<<24)|(y<<16)|(m<<8)|c;
 }

 return(NULL);
}




os_error * csbgr2cmyk3232(int * s,int * d,int size)
{
 int word;
 int c;
 int m;
 int y;
 int k;

 while(size--)
 {
  word=*s++;
  y=0xFF-(word & 0xFF);
  m=0xFF-((word & 0xFF00)>>8);
  c=0xFF-((word & 0xFF0000)>>16);

  k=MIN(c,m);
  k=MIN(k,y);

  c-=k;
  m-=k;
  y-=k;

  *d++=(k<<24)|(y<<16)|(m<<8)|c;
 }

 return(NULL);
}




os_error * csbgr2cmyk2432(int * s,int * d,int size)
{
 int word;
 int c;
 int m;
 int y;
 int k;
 char * sp;

 sp=(char*)s;

 while(size--)
 {
  word=*s++;
  y=0xFF-(*sp++);
  m=0xFF-(*sp++);
  c=0xFF-(*sp++);

  k=MIN(c,m);
  k=MIN(k,y);

  c-=k;
  m-=k;
  y-=k;

  *d++=(k<<24)|(y<<16)|(m<<8)|c;
 }

 return(NULL);
}




os_error * csrgb2cmykpal32(int * s,int * d,int size)
{
 int word;
 int c;
 int m;
 int y;
 int k;

 while(size--)
 {
  word=*s++;
  c=0xFF-((word & 0xFF00)>>8);
  m=0xFF-((word & 0xFF0000)>>16);
  y=0xFF-((word & 0xFF000000)>>24);

  k=MIN(c,m);
  k=MIN(k,y);

  c-=k;
  m-=k;
  y-=k;

  *d++=(k<<24)|(y<<16)|(m<<8)|c;
 }


 return(NULL);
}




os_error * csrgb2cmyk1632(int * s,int * d,int size)
{
 int word;
 int c;
 int m;
 int y;
 int k;

 while(size--)
 {
  word=*s++;

  c=cstab16[0x1F-((word &   0x1F))];
  m=cstab16[0x1F-((word &  0x3E0)>>5)];
  y=cstab16[0x1F-((word & 0x7C00)>>10)];

  k=MIN(c,m);
  k=MIN(k,y);

  c-=k;
  m-=k;
  y-=k;


  *d++=(k<<(24))|(y<<(16))|(m<<(8))|(c);

  c=cstab16[0x1F-((word & 0x1F0000)>>16)];
  m=cstab16[0x1F-((word & 0x3E00000)>>21)];
  y=cstab16[0x1F-((word & 0x7C000000)>>26)];

  k=MIN(c,m);
  k=MIN(k,y);

  c-=k;
  m-=k;
  y-=k;


  *d++=(k<<(24))|(y<<(16))|(m<<(8))|(c);
 }

 return(NULL);
}






os_error * csbgr2cmyk1632(int * s,int * d,int size)
{
 int word;
 int c;
 int m;
 int y;
 int k;

 while(size--)
 {
  word=*s++;

  y=cstab16[0x1F-((word &   0x1F))];
  m=cstab16[0x1F-((word &  0x3E0)>>5)];
  c=cstab16[0x1F-((word & 0x7C00)>>10)];

  k=MIN(c,m);
  k=MIN(k,y);

  c-=k;
  m-=k;
  y-=k;


  *d++=(k<<(24))|(y<<(16))|(m<<(8))|(c);

  y=cstab16[0x1F-((word & 0x1F0000)>>16)];
  m=cstab16[0x1F-((word & 0x3E00000)>>21)];
  c=cstab16[0x1F-((word & 0x7C000000)>>26)];

  k=MIN(c,m);
  k=MIN(k,y);

  c-=k;
  m-=k;
  y-=k;


  *d++=(k<<(24))|(y<<(16))|(m<<(8))|(c);
 }

 return(NULL);
}







os_error * cscmyk2rgb32pal(int * s,int * d,int size)
{
 int r;
 int g;
 int b;
 int c;
 int m;
 int y;
 int k;
 int cmyk;


 while(size--)
 {
  cmyk=*s++;

  k=(cmyk>>24) & 0xFF;
  y=(cmyk>>16) & 0xFF;
  m=(cmyk>>8) & 0xFF;
  c=cmyk & 0xFF;

  r=255-(c+k);
  if(r<0) r=0;

  g=255-(m+k);
  if(g<0) g=0;

  b=255-(y+k);
  if(b<0) b=0;

  *d++=(b<<24)|(g<<16)|(r<<8);
 }

 return(NULL);
}



os_error * cscmyk2rgb3216(int * s,int * d,int size)
{
 int r;
 int g;
 int b;
 int c;
 int m;
 int y;
 int k;
 int cmyk;
 int word;
 int shift;

 word=0; /* compiler */

 shift=0;

 while(size--)
 {
  cmyk=*s++;

  k=(cmyk>>24) & 0xFF;
  y=(cmyk>>16) & 0xFF;
  m=(cmyk>>8) & 0xFF;
  c=cmyk & 0xFF;

  r=255-(c+k);
  if(r<0) r=0;
  r&=0xF8;

  g=255-(m+k);
  if(g<0) g=0;
  g&=0xF8;

  b=255-(y+k);
  if(b<0) b=0;
  b&=0xF8;

  if(shift) *d++=(b<<23)|(g<<18)|(r<<13)|word;
  else       word=(b<<7)|(g<<2)|(r>>3);

  shift=1-shift;
 }

 if(shift) *d++=word;

 return(NULL);
}





os_error * cscmyk2bgr3216(int * s,int * d,int size)
{
 int r;
 int g;
 int b;
 int c;
 int m;
 int y;
 int k;
 int cmyk;
 int word;
 int shift;

 word=0; /* compiler */

 shift=0;

 while(size--)
 {
  cmyk=*s++;

  k=(cmyk>>24) & 0xFF;
  y=(cmyk>>16) & 0xFF;
  m=(cmyk>>8) & 0xFF;
  c=cmyk & 0xFF;

  r=255-(c+k);
  if(r<0) r=0;
  r&=0xF8;

  g=255-(m+k);
  if(g<0) g=0;
  g&=0xF8;

  b=255-(y+k);
  if(b<0) b=0;
  b&=0xF8;

  if(shift) *d++=(r<<23)|(g<<18)|(b<<13)|word;
  else       word=(r<<7)|(g<<2)|(b>>3);

  shift=1-shift;
 }

 if(shift) *d++=word;

 return(NULL);
}






os_error * cscmyk2rgb3232(int * s,int * d,int size)
{
 int r;
 int g;
 int b;
 int c;
 int m;
 int y;
 int k;
 int cmyk;


 while(size--)
 {
  cmyk=*s++;

  k=(cmyk>>24) & 0xFF;
  y=(cmyk>>16) & 0xFF;
  m=(cmyk>>8) & 0xFF;
  c=cmyk & 0xFF;

  r=255-(c+k);
  if(r<0) r=0;

  g=255-(m+k);
  if(g<0) g=0;

  b=255-(y+k);
  if(b<0) b=0;

  *d++=(b<<16)|(g<<8)|r;
 }

 return(NULL);
}




os_error * cscmyk2bgr3232(int * s,int * d,int size)
{
 int r;
 int g;
 int b;
 int c;
 int m;
 int y;
 int k;
 int cmyk;


 while(size--)
 {
  cmyk=*s++;

  k=(cmyk>>24) & 0xFF;
  y=(cmyk>>16) & 0xFF;
  m=(cmyk>>8) & 0xFF;
  c=cmyk & 0xFF;

  r=255-(c+k);
  if(r<0) r=0;

  g=255-(m+k);
  if(g<0) g=0;

  b=255-(y+k);
  if(b<0) b=0;

  *d++=(r<<16)|(g<<8)|b;
 }

 return(NULL);
}





os_error * cscmyk2bgr3224(int * s,int * d,int size)
{
 int r;
 int g;
 int b;
 int c;
 int m;
 int y;
 int k;
 int cmyk;
 char * dp;


 dp=(char*)d;


 while(size--)
 {
  cmyk=*s++;

  k=(cmyk>>24) & 0xFF;
  y=(cmyk>>16) & 0xFF;
  m=(cmyk>>8) & 0xFF;
  c=cmyk & 0xFF;

  b=255-(y+k);
  if(b<0) b=0;
  *dp++=b;

  g=255-(m+k);
  if(g<0) g=0;
  *dp++=g;

  r=255-(c+k);
  if(r<0) r=0;
  *dp++=r;
 }

 return(NULL);
}









os_error * csrgb32torgb32(int * s,int * d,int size,int key,int mask)
{
 int word;
 int tint;
 int c;
 int m;
 int y;
 int k;

 if(key==KEYCYAN)
 {
  if(mask==0)
  {
   while(size--)
   {
    word=*s++;
    c=0xFF-(word & 0xFF);
    m=0xFF-((word & 0xFF00)>>8);
    y=0xFF-((word & 0xFF0000)>>16);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0xFF-(c-k);     /* cyan */
    *d++=(tint<<16)|(tint<<8)|tint;
   }
  }
  else
  {
   while(size--)
   {
    word=*s++;
    c=0xFF-(word & 0xFF);
    m=0xFF-((word & 0xFF00)>>8);
    y=0xFF-((word & 0xFF0000)>>16);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0xFF-(c-k);     /* cyan */

    *d++=0xFFFF00|tint;
   }
  }
 }
 else
 if(key==KEYYELLOW)
 {
  if(mask==0)
  {
   while(size--)
   {
    word=*s++;
    c=0xFF-(word & 0xFF);
    m=0xFF-((word & 0xFF00)>>8);
    y=0xFF-((word & 0xFF0000)>>16);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0xFF-(y-k);     /* yellow */

    *d++=(tint<<16)|(tint<<8)|tint;
   }
  }
  else
  {
   while(size--)
   {
    word=*s++;
    c=0xFF-(word & 0xFF);
    m=0xFF-((word & 0xFF00)>>8);
    y=0xFF-((word & 0xFF0000)>>16);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0xFF-(y-k);     /* yellow */

    *d++=0xFFFF|(tint<<16);
   }
  }
 }
 else
 if(key==KEYMAGENTA)
 {
  if(mask==0)
  {
   while(size--)
   {
    word=*s++;
    c=0xFF-(word & 0xFF);
    m=0xFF-((word & 0xFF00)>>8);
    y=0xFF-((word & 0xFF0000)>>16);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0xFF-(m-k);     /* magenta */

    *d++=(tint<<16)|(tint<<8)|tint;
   }
  }
  else
  {
   while(size--)
   {
    word=*s++;
    c=0xFF-(word & 0xFF);
    m=0xFF-((word & 0xFF00)>>8);
    y=0xFF-((word & 0xFF0000)>>16);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0xFF-(m-k);     /* magenta */

    *d++=0xFF00FF|(tint<<8);
   }
  }
 }
 else
 if(key==KEYBLACK)
 {
  while(size--)
  {
   word=*s++;
   c=0xFF-(word & 0xFF);
   m=0xFF-((word & 0xFF00)>>8);
   y=0xFF-((word & 0xFF0000)>>16);

   k=MIN(c,m);
   k=MIN(k,y);

   tint=0xFF-k;     /* black */

   *d++=(tint<<16)|(tint<<8)|tint;
  }
 }

 return(NULL);
}




os_error * csbgr32tobgr32(int * s,int * d,int size,int key,int mask)
{
 int word;
 int tint;
 int c;
 int m;
 int y;
 int k;

 if(key==KEYCYAN)
 {
  if(mask==0)
  {
   while(size--)
   {
    word=*s++;
    y=0xFF-(word & 0xFF);
    m=0xFF-((word & 0xFF00)>>8);
    c=0xFF-((word & 0xFF0000)>>16);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0xFF-(c-k);     /* cyan */
    *d++=(tint<<16)|(tint<<8)|tint;
   }
  }
  else
  {
   while(size--)
   {
    word=*s++;
    y=0xFF-(word & 0xFF);
    m=0xFF-((word & 0xFF00)>>8);
    c=0xFF-((word & 0xFF0000)>>16);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0xFF-(c-k);     /* cyan */

    *d++=0xFFFF|(tint<<16);
   }
  }
 }
 else
 if(key==KEYYELLOW)
 {
  if(mask==0)
  {
   while(size--)
   {
    word=*s++;
    y=0xFF-(word & 0xFF);
    m=0xFF-((word & 0xFF00)>>8);
    c=0xFF-((word & 0xFF0000)>>16);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0xFF-(y-k);     /* yellow */

    *d++=(tint<<16)|(tint<<8)|tint;
   }
  }
  else
  {
   while(size--)
   {
    word=*s++;
    y=0xFF-(word & 0xFF);
    m=0xFF-((word & 0xFF00)>>8);
    c=0xFF-((word & 0xFF0000)>>16);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0xFF-(y-k);     /* yellow */

    *d++=0xFFFF00|(tint);
   }
  }
 }
 else
 if(key==KEYMAGENTA)
 {
  if(mask==0)
  {
   while(size--)
   {
    word=*s++;
    y=0xFF-(word & 0xFF);
    m=0xFF-((word & 0xFF00)>>8);
    c=0xFF-((word & 0xFF0000)>>16);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0xFF-(m-k);     /* magenta */

    *d++=(tint<<16)|(tint<<8)|tint;
   }
  }
  else
  {
   while(size--)
   {
    word=*s++;
    y=0xFF-(word & 0xFF);
    m=0xFF-((word & 0xFF00)>>8);
    c=0xFF-((word & 0xFF0000)>>16);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0xFF-(m-k);     /* magenta */

    *d++=0xFF00FF|(tint<<8);
   }
  }
 }
 else
 if(key==KEYBLACK)
 {
  while(size--)
  {
   word=*s++;
   y=0xFF-(word & 0xFF);
   m=0xFF-((word & 0xFF00)>>8);
   c=0xFF-((word & 0xFF0000)>>16);

   k=MIN(c,m);
   k=MIN(k,y);

   tint=0xFF-k;     /* black */

   *d++=(tint<<16)|(tint<<8)|tint;
  }
 }

 return(NULL);
}








os_error * csbgr24tobgr24(int * s,int * d,int size,int key,int mask)
{
 int tint;
 int c;
 int m;
 int y;
 int k;
 char * sp;
 char * dp;


 sp=(char*)s;
 dp=(char*)d;


 if(key==KEYCYAN)
 {
  if(mask==0)
  {
   while(size--)
   {
    y=0xFF-(*sp++);
    m=0xFF-(*sp++);
    c=0xFF-(*sp++);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0xFF-(c-k);     /* cyan */
    *dp++=tint;
    *dp++=tint;
    *dp++=tint;
   }
  }
  else
  {
   while(size--)
   {
    y=0xFF-(*sp++);
    m=0xFF-(*sp++);
    c=0xFF-(*sp++);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0xFF-(c-k);     /* cyan */

    *dp++=0xFF;
    *dp++=0xFF;
    *dp++=tint;
   }
  }
 }
 else
 if(key==KEYYELLOW)
 {
  if(mask==0)
  {
   while(size--)
   {
    y=0xFF-(*sp++);
    m=0xFF-(*sp++);
    c=0xFF-(*sp++);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0xFF-(y-k);     /* yellow */

    *dp++=tint;
    *dp++=tint;
    *dp++=tint;
   }
  }
  else
  {
   while(size--)
   {
    y=0xFF-(*sp++);
    m=0xFF-(*sp++);
    c=0xFF-(*sp++);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0xFF-(y-k);     /* yellow */

    *dp++=tint;
    *dp++=0xFF;
    *dp++=0xFF;
   }
  }
 }
 else
 if(key==KEYMAGENTA)
 {
  if(mask==0)
  {
   while(size--)
   {
    y=0xFF-(*sp++);
    m=0xFF-(*sp++);
    c=0xFF-(*sp++);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0xFF-(m-k);     /* magenta */

    *dp++=tint;
    *dp++=tint;
    *dp++=tint;
   }
  }
  else
  {
   while(size--)
   {
    y=0xFF-(*sp++);
    m=0xFF-(*sp++);
    c=0xFF-(*sp++);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0xFF-(m-k);     /* magenta */

    *dp++=0xFF;
    *dp++=tint;
    *dp++=0xFF;
   }
  }
 }
 else
 if(key==KEYBLACK)
 {
  while(size--)
  {
   y=0xFF-(*sp++);
   m=0xFF-(*sp++);
   c=0xFF-(*sp++);

   k=MIN(c,m);
   k=MIN(k,y);

   tint=0xFF-k;     /* black */

   *dp++=tint;
   *dp++=tint;
   *dp++=tint;
  }
 }

 return(NULL);
}









os_error * csrgb16torgb16(int * s,int * d,int size,int key,int mask)
{
 int word;
 int tint;
 int dest;
 int c;
 int m;
 int y;
 int k;

 if(key==KEYCYAN)
 {
  if(mask==0)
  {
   while((size-=2)>-2)
   {
    word=*s++;

    c=0x1F-(word & 0x1F);
    m=0x1F-((word & 0x3E0)>>5);
    y=0x1F-((word & 0x7C00)>>10);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0x1F-(c-k);     /* cyan */

    dest=(tint<<10)|(tint<<5)|tint;


    c=0x1F-((word & 0x1F0000)>>16);
    m=0x1F-((word & 0x3E00000)>>21);
    y=0x1F-((word & 0x7C000000)>>26);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0x1F-(c-k);     /* cyan */

    dest|=(tint<<26)|(tint<<21)|(tint<<16);

    *d++=dest;
   }
  }
  else
  {
   while((size-=2)>-2)
   {
    word=*s++;

    c=0x1F-((word &   0x1F));
    m=0x1F-((word &  0x3E0)>>5);
    y=0x1F-((word & 0x7C00)>>10);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0x1F-(c-k);     /* cyan */

    dest=0x7FE0|tint;

    c=0x1F-((word &   0x1F0000)>>16);
    m=0x1F-((word &  0x3E00000)>>21);
    y=0x1F-((word & 0x7C000000)>>26);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0x1F-(c-k);     /* cyan */

    dest|=((0x7FE0|tint)<<16);

    *d++=dest;
   }
  }
 }
 else
 if(key==KEYYELLOW)
 {
  if(mask==0)
  {
   while((size-=2)>-2)
   {
    word=*s++;

    c=0x1F-(word & 0x1F);
    m=0x1F-((word & 0x3E0)>>5);
    y=0x1F-((word & 0x7C00)>>10);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0x1F-(y-k);     /* yellow */

    dest=(tint<<10)|(tint<<5)|tint;


    c=0x1F-((word &   0x1F0000)>>16);
    m=0x1F-((word &  0x3E00000)>>21);
    y=0x1F-((word & 0x7C000000)>>26);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0x1F-(y-k);     /* yellow */

    dest|=(tint<<26)|(tint<<21)|(tint<<16);

    *d++=dest;
   }
  }
  else
  {
   while((size-=2)>-2)
   {
    word=*s++;

    c=0x1F-((word &   0x1F));
    m=0x1F-((word &  0x3E0)>>5);
    y=0x1F-((word & 0x7C00)>>10);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0x1F-(y-k);     /* yellow */

    dest=0x3FF|(tint<<10);

    c=0x1F-((word & 0x1F0000)>>16);
    m=0x1F-((word & 0x3E00000)>>21);
    y=0x1F-((word & 0x7C000000)>>26);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0x1F-(y-k);     /* yellow */

    dest|=0x3FF0000|(tint<<26);

    *d++=dest;
   }
  }
 }
 else
 if(key==KEYMAGENTA)
 {
  if(mask==0)
  {
   while((size-=2)>-2)
   {
    word=*s++;

    c=0x1F-((word &   0x1F));
    m=0x1F-((word &  0x3E0)>>5);
    y=0x1F-((word & 0x7C00)>>10);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0x1F-(m-k);     /* magenta */

    dest=(tint<<10)|(tint<<5)|tint;


    c=0x1F-((word &   0x1F0000)>>16);
    m=0x1F-((word &  0x3E00000)>>21);
    y=0x1F-((word & 0x7C000000)>>26);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0x1F-(m-k);     /* magenta */

    dest|=(tint<<26)|(tint<<21)|(tint<<16);

    *d++=dest;
   }
  }
  else
  {
   while((size-=2)>-2)
   {
    word=*s++;

    c=0x1F-(word & 0x1F);
    m=0x1F-((word & 0x3E0)>>5);
    y=0x1F-((word & 0x7C00)>>10);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0x1F-(m-k);     /* magenta */

    dest=0x7C1F|(tint<<5);

    c=0x1F-((word & 0x1F0000)>>16);
    m=0x1F-((word & 0x3E00000)>>21);
    y=0x1F-((word & 0x7C000000)>>26);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0x1F-(m-k);     /* magenta */

    dest|=0x7C1F0000|(tint<<21);

    *d++=dest;
   }
  }
 }
 else
 if(key==KEYBLACK)
 {
  while((size-=2)>-2)
  {
   word=*s++;

   c=0x1F-(word & 0x1F);
   m=0x1F-((word & 0x3E0)>>5);
   y=0x1F-((word & 0x7C00)>>10);

   k=MIN(c,m);
   k=MIN(k,y);

   tint=0x1F-k;     /* black */

   dest=(tint<<10)|(tint<<5)|tint;


   c=0x1F-((word & 0x1F0000)>>16);
   m=0x1F-((word & 0x3E00000)>>21);
   y=0x1F-((word & 0x7C000000)>>26);

   k=MIN(c,m);
   k=MIN(k,y);

   tint=0x1F-k;     /* black */

   dest|=(tint<<26)|(tint<<21)|(tint<<16);

   *d++=dest;
  }
 }

 return(NULL);
}









os_error * csbgr16tobgr16(int * s,int * d,int size,int key,int mask)
{
 int word;
 int tint;
 int dest;
 int c;
 int m;
 int y;
 int k;

 if(key==KEYCYAN)
 {
  if(mask==0)
  {
   while((size-=2)>-2)
   {
    word=*s++;

    y=0x1F-(word & 0x1F);
    m=0x1F-((word & 0x3E0)>>5);
    c=0x1F-((word & 0x7C00)>>10);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0x1F-(c-k);     /* cyan */

    dest=(tint<<10)|(tint<<5)|tint;


    y=0x1F-((word & 0x1F0000)>>16);
    m=0x1F-((word & 0x3E00000)>>21);
    c=0x1F-((word & 0x7C000000)>>26);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0x1F-(c-k);     /* cyan */

    dest|=(tint<<26)|(tint<<21)|(tint<<16);

    *d++=dest;
   }
  }
  else
  {
   while((size-=2)>-2)
   {
    word=*s++;

    y=0x1F-((word &   0x1F));
    m=0x1F-((word &  0x3E0)>>5);
    c=0x1F-((word & 0x7C00)>>10);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0x1F-(c-k);     /* cyan */


    dest=0x3FF|(tint<<10);

    y=0x1F-((word &   0x1F0000)>>16);
    m=0x1F-((word &  0x3E00000)>>21);
    c=0x1F-((word & 0x7C000000)>>26);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0x1F-(c-k);     /* cyan */

    dest|=0x3FF0000|(tint<<26);

    *d++=dest;
   }
  }
 }
 else
 if(key==KEYYELLOW)
 {
  if(mask==0)
  {
   while((size-=2)>-2)
   {
    word=*s++;

    y=0x1F-(word & 0x1F);
    m=0x1F-((word & 0x3E0)>>5);
    c=0x1F-((word & 0x7C00)>>10);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0x1F-(y-k);     /* yellow */

    dest=(tint<<10)|(tint<<5)|tint;


    y=0x1F-((word &   0x1F0000)>>16);
    m=0x1F-((word &  0x3E00000)>>21);
    c=0x1F-((word & 0x7C000000)>>26);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0x1F-(y-k);     /* yellow */

    dest|=(tint<<26)|(tint<<21)|(tint<<16);

    *d++=dest;
   }
  }
  else
  {
   while((size-=2)>-2)
   {
    word=*s++;

    y=0x1F-((word &   0x1F));
    m=0x1F-((word &  0x3E0)>>5);
    c=0x1F-((word & 0x7C00)>>10);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0x1F-(y-k);     /* yellow */
    dest=0x7FE0|tint;


    y=0x1F-((word & 0x1F0000)>>16);
    m=0x1F-((word & 0x3E00000)>>21);
    c=0x1F-((word & 0x7C000000)>>26);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0x1F-(y-k);     /* yellow */
    dest|=((0x7FE0|tint)<<16);

    *d++=dest;
   }
  }
 }
 else
 if(key==KEYMAGENTA)
 {
  if(mask==0)
  {
   while((size-=2)>-2)
   {
    word=*s++;

    y=0x1F-((word &   0x1F));
    m=0x1F-((word &  0x3E0)>>5);
    c=0x1F-((word & 0x7C00)>>10);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0x1F-(m-k);     /* magenta */

    dest=(tint<<10)|(tint<<5)|tint;


    y=0x1F-((word &   0x1F0000)>>16);
    m=0x1F-((word &  0x3E00000)>>21);
    c=0x1F-((word & 0x7C000000)>>26);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0x1F-(m-k);     /* magenta */

    dest|=(tint<<26)|(tint<<21)|(tint<<16);

    *d++=dest;
   }
  }
  else
  {
   while((size-=2)>-2)
   {
    word=*s++;

    y=0x1F-(word & 0x1F);
    m=0x1F-((word & 0x3E0)>>5);
    c=0x1F-((word & 0x7C00)>>10);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0x1F-(m-k);     /* magenta */

    dest=0x7C1F|(tint<<5);

    y=0x1F-((word & 0x1F0000)>>16);
    m=0x1F-((word & 0x3E00000)>>21);
    c=0x1F-((word & 0x7C000000)>>26);

    k=MIN(c,m);
    k=MIN(k,y);

    tint=0x1F-(m-k);     /* magenta */

    dest|=0x7C1F0000|(tint<<21);

    *d++=dest;
   }
  }
 }
 else
 if(key==KEYBLACK)
 {
  while((size-=2)>-2)
  {
   word=*s++;

   y=0x1F-(word & 0x1F);
   m=0x1F-((word & 0x3E0)>>5);
   c=0x1F-((word & 0x7C00)>>10);

   k=MIN(c,m);
   k=MIN(k,y);

   tint=0x1F-k;     /* black */

   dest=(tint<<10)|(tint<<5)|tint;


   y=0x1F-((word & 0x1F0000)>>16);
   m=0x1F-((word & 0x3E00000)>>21);
   c=0x1F-((word & 0x7C000000)>>26);

   k=MIN(c,m);
   k=MIN(k,y);

   tint=0x1F-k;     /* black */

   dest|=(tint<<26)|(tint<<21)|(tint<<16);

   *d++=dest;
  }
 }

 return(NULL);
}



