// MkCMYK.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <stdlib.h>
#include <string.h>

#include <windows.h>





char * fs_strcat(char * path,char * filename)
{
 char * p;

 p=path+strlen(path);
 if(p>path && *(p-1)=='\\')
 {

 }
 else
 {
  *p++='\\';
 }

 strcpy(p,filename);

 return(path);
}




char * fs_leaf(char * filename)
{
 char * p;

        p=strrchr(filename,'\\');
 if(!p) p=strrchr(filename,'/');
 if(!p)
 {
  p=strrchr(filename,':');
  if(!p) p=filename;
  else   p+=1;
 } else  p+=1;
 return(p);
}








const int tilex=8;
const int tiley=8;

const int arrayx=9;
const int arrayy=9;

const int slicex=9;
const int slicey=9;



const int sasize=16;
const int shdrsize=11*4;



static char * makesprite(int xpix,int ypix)
{
 int    sdatasize=xpix*ypix*4;
 int    ssize=sasize+shdrsize+sdatasize;
 char * p;

 p=(char*)malloc(ssize);

 memset(p,0,ssize);

 *(int*)p=ssize;
 *(int*)(p+4)=1;
 *(int*)(p+8)=sasize;
 *(int*)(p+12)=ssize;

 *(int*)(p+(sasize+0))=shdrsize+sdatasize; // next
 *(int*)(p+(sasize+4))=0x60606060;          // name
 *(int*)(p+(sasize+8))=0x20202020;
 *(int*)(p+(sasize+12))=0x20202020;
 *(int*)(p+(sasize+16))=xpix-1;            // width in words-1
 *(int*)(p+(sasize+20))=ypix-1;            // height in lines-1
 *(int*)(p+(sasize+24))=0;                 // lbit
 *(int*)(p+(sasize+28))=31;                // rbit
 *(int*)(p+(sasize+32))=shdrsize;          // image offset
 *(int*)(p+(sasize+36))=shdrsize;          // mask offset
 *(int*)(p+(sasize+40))=1 | (90<<1) | (90<<14) | (7<<27);


 return(p);
}






static settile(int ay,int ax,int ty,int tx,int v,char * s,int xpix)
{
 char * p;
 int    xx;
 int    yy;

 p=s+sasize+shdrsize;
 p+=(tilex/2+tx*tilex+ax*(arrayx+1)*tilex)*4;
 p+=(tiley/2+ty*tiley+ay*(arrayy+1)*tiley)*xpix*4;

 for(yy=0;yy<tiley;yy++)
 {
  for(xx=0;xx<tilex;xx++)
  {
   *(int*)(p+(xx*4))=v;
  }
  p+=xpix*4;
 }
}


//DEF PROCSAVESPRITE(A$)
//OSCLI("save "+A$+" "+STR$~(S%+4)+" "+STR$~(S%+S%!(0)))
//OSCLI("settype "+A$+" Sprite")
//ENDPROC


static void savesprite(char * name,char * s)
{
 FILE * fp;

// printf("name %s",name);

 fp=fopen(name,"wb+");
 if(fp)
 {
//  printf("write %d",*(int*)s);

  fwrite(s+4,*(int*)s,1,fp);

  fclose(fp);
 }
}






int main(int argc,char* argv[])
{
 char * p;
 char * q;
 char   path[MAX_PATH];
 int    xpix;
 int    ypix;
 int    c;
 int    m;
 int    y;
 int    k;
 int    C;
 int    M;
 int    Y;
 int    K;


 xpix=(arrayx+1)*tilex*slicex;
 ypix=(arrayy+1)*tiley*slicey;


 p=makesprite(xpix,ypix);

 k=0;
 for(K=0;K<slicey;K++)
 {
  m=0;
  for(M=0;M<slicex;M++)
  {
   c=0;
   for(C=0;C<arrayy;C++)
   {
    y=0;
    for(Y=0;Y<arrayx;Y++)
    {
     settile(K,M,C,Y,(k<<24) | (y<<16) | (m<<8) | c,p,xpix);
     if(y==0) y=31; else y+=32;
    }
    if(c==0) c=31; else c+=32;
   }
   if(m==0) m=31; else m+=32;
  }
  if(k==0) k=31; else k+=32;
 }



 strcpy(path,argv[0]);

 q=fs_leaf(path);
 *q=0;
// printf("leaf %s\r\n",q);

 fs_strcat(path,"cmyk.spr");

 savesprite(path,p);

	return 0;
}

